local config = require("config")

print("[winterIsComing] winterIsComingMod loaded!!\n")
print("[winterIsComing] Mod created by YinjiD")
print("[winterIsComing] https://next.nexusmods.com/profile/YinjiD/about-me")

function checkIfToSpawnWinterStorm(checkedStorm) 
    if checkedStorm then
        return false
    end

    local ifSpawnWinterStorm = false 
    local PawnCPP = FindFirstOf("PawnCPP")
    if not PawnCPP:IsValid() then
        print("[winterIsComing] Couldn't get PawnCPP instance.\n")
        return
    end

    local dayOfYear = PawnCPP:getDayOfTheYear()
    local yearsSurvived = PawnCPP:getYearsSurvived()

    local startRange = 235
    local endRange = 295

    local bonus_chance_by_year = 0
    if yearsSurvived > 5 then
        bonus_chance_by_year = bonus_chance_by_year + 5
    end
    if yearsSurvived > 10 then
        bonus_chance_by_year = bonus_chance_by_year + 5
    end
    if yearsSurvived > 15 then
        bonus_chance_by_year = bonus_chance_by_year + 5
    end
    if yearsSurvived > 20 then
        bonus_chance_by_year = bonus_chance_by_year + 5
    end

    if (dayOfYear > startRange and dayOfYear < endRange) and yearsSurvived > 2 then
        updateConfigFile("currentYearChecked", yearsSurvived)
        local rand = math.random(1, 100) 
        print(string.format("Rolling chance to summon winterStorm: %s - %s -> %s",rand, config.winterStorm_chance, rand <= config.winterStorm_chance))
        if rand <= config.winterStorm_chance + bonus_chance_by_year then
            ifSpawnWinterStorm = true
        else
            ifSpawnWinterStorm = false
        end
    end

    return ifSpawnWinterStorm
end

function spawnWinterStorm()
    local PawnCPP = FindFirstOf("PawnCPP")
    if not PawnCPP:IsValid() then
        print("[winterIsComing] Couldn't get PawnCPP instance.\n")
        return true
    end

    local AWeatherMaster = FindFirstOf("WeatherMaster")
    if not AWeatherMaster:IsValid() then
        print("[winterIsComing] Couldn't get AWeatherMaster instance.\n")
        return true
    end

    local RTSMultiEngineCPP = FindFirstOf("RTSMultiEngineCPP")
    if not RTSMultiEngineCPP:IsValid() then
        print("[winterIsComing] Couldn't get RTSMultiEngineCPP instance.\n")
        return true
    end

    local dayOfYear = PawnCPP:getDayOfTheYear()
    local yearsSurvived = PawnCPP:getYearsSurvived()

    if config.timesWinterStorm == 0 then
        updateConfigFile("timesWinterStorm", math.random(3,12))
    end

    if (dayOfYear >= 0 and dayOfYear < 40) then
        if config.changeWeather == 0 then
            updateConfigFile("changeWeather", 1)
        end
        if config.currentWinterStorm <= config.timesWinterStorm then
            if dayOfYear >= 28 then
                RTSMultiEngineCPP:setDay(1)
                print("[winterIsComing] WinterStorm in progress..")
                updateConfigFile("currentWinterStorm", config.currentWinterStorm + 1)
                print(string.format("[winterIsComing] currentWinterStorm: %s out of timesWinterStorm: %s", config.currentWinterStorm, config.timesWinterStorm + 2))
                PawnCPP:playEventMessage(FName("stormContinues"), "The storm continues", string.format("%s more months to go..", config.timesWinterStorm - config.currentWinterStorm + 2 ))

                local rand_lowerApproval = math.random(1, 100)
                if rand_lowerApproval <= config.lowerApproval_chance then
                    runDebuffChances("lowerApproval")
                end

                local rand_sick = math.random(1, 100)
                if rand_sick <= config.sick_chance then
                    runDebuffChances("sick")
                    PawnCPP:playEventMessage(FName("sick"), "Sickness spreads!", "Villagers are getting sick..")
                end
            end
        else
            if config.isWinterStorm == 1 then
                print("[winterIsComing] WinterStorm is over..")
                PawnCPP:playEventMessage(FName("stormOver"), "The storm is over..", "Life can now go on..")
                updateConfigFile("isWinterStorm", 0)
                updateConfigFile("timesWinterStorm", 0)
                updateConfigFile("currentWinterStorm", 0)
                updateConfigFile("changeWeather", 0)
                clearSick()
            end
        end
    else
        -- print(string.format("[winterIsComing] Not Spawning WinterStorm because not in dayRange 0-60"))
        if config.isWinterStorm == 0 then
            updateConfigFile("timesWinterStorm", 0)
            updateConfigFile("currentWinterStorm", 0)
            updateConfigFile("isWinterStorm", 0)
        end
    end
end

function runDebuffChances(debuff)
    local RTSMultiEngineCPP = FindFirstOf("RTSMultiEngineCPP")
    if not RTSMultiEngineCPP:IsValid() then
        print("[winterIsComing] Couldn't get RTSMultiEngineCPP instance.\n")
        return
    end

    local pawns = RTSMultiEngineCPP.pawns
    if debuff == "lowerApproval" then
        -- TODO --
    elseif debuff == "sick" then
        -- Currently may cause weird graphical artifacts when triggered, requires reloading the savegame to fix --
        for i=1, #pawns do
            local pawn = pawns[i]
            if pawn.isAI == false then
                local commandedRegions = pawn.getAllCommandedRegions()
                for i=1, #commandedRegions do
                    local region = commandedRegions[i]:get()
                    local residents = region.residents
                    if residents:GetArrayNum() ~= 0 then
                        local amount_sick = math.random(1, residents:GetArrayNum()//2)
                        for i=1, amount_sick do
                            local resident = residents[i]
                            if not resident.isAnimal then
                                resident.disease = 0.5
                            else
                                resident.disease = 0
                            end
                        end
                    end
                end
            end
        end
    else
        print("[winterIsComing] Invalid debuff type")
    end
end

function clearSick()
    local RTSMultiEngineCPP = FindFirstOf("RTSMultiEngineCPP")
    if not RTSMultiEngineCPP:IsValid() then
        print("[winterIsComing] Couldn't get RTSMultiEngineCPP instance.\n")
        return
    end

    local pawns = RTSMultiEngineCPP.pawns
    -- Currently may cause weird graphical artifacts when triggered, requires reloading the savegame to fix --
    for i=1, #pawns do
        local pawn = pawns[i]
        if pawn.isAI == false then
            local commandedRegions = pawn.getAllCommandedRegions()
            for i=1, #commandedRegions do
                local region = commandedRegions[i]:get()
                local residents = region.residents
                if residents:GetArrayNum() ~= 0 then
                    local amount = residents:GetArrayNum()
                    for i=1, amount do
                        local resident = residents[i]
                        resident.disease = 0
                    end
                end
            end
        end
    end
end

function wasSpawnWinterStormCheckedThisYear()
    local checkedStorm = false
    local PawnCPP = FindFirstOf("PawnCPP")
    if not PawnCPP:IsValid() then
        print("[winterIsComing] Couldn't get PawnCPP instance.\n")
        checkedStorm = true
    end

    local yearsSurvived = PawnCPP:getYearsSurvived()
    if config.currentYearChecked + 1 <= yearsSurvived then
        checkedStorm = false
    else
        checkedStorm = true
    end

    return checkedStorm
end

function updateConfigFile(varName, varValue)
    local function deepen(str, r)
      return (" "):rep(r) .. str
    end

    local function basicSerial(value, depth) -- depth only used internally
      depth = depth or 0
      if type(value) == "table" then
        local s = deepen("{\n", depth)
        for k, v in pairs(value) do
          if type(k) == "table" or type(k) == "function" then
            error("Cannot serialize table or function reference as key.", depth / 2 + 2)
          end
          s = s .. deepen(string.format("%s = %s,\n",  basicSerial(k, 0), basicSerial(v, depth + 2)), depth + 2)
        end
        return s .. deepen("}", depth)
      elseif type(value) == "string" then
        return value
      elseif type(value) == "function" then
        error("Cannot serialize type: function", depth / 2 + 2)
      end
      return tostring(value)
    end

    local function basicUnserial(text)
      return load("return " .. text)() -- really lazy way, but works. Be warned of potential code injection with this though.
    end

    local file = io.open("Mods/winterIsComingMod/scripts/config.lua", "w")

    config[varName] = varValue
    file:write(string.format("local _yd_mod_config = " .. basicSerial(config) .. "\nreturn _yd_mod_config"))
    file:close()
end

function initializeConfigFile()
    ExecuteWithDelay(60000, function ()
        local RTSMultiEngineCPP = FindFirstOf("RTSMultiEngineCPP")
        if not RTSMultiEngineCPP:IsValid() then
            print("[winterIsComing] Couldn't get RTSMultiEngineCPP instance.\n")
            return
        end
        local currentDaysTotal = RTSMultiEngineCPP.getDaysTotal()

        

        if currentDaysTotal <= 2 then
            print("[winterIsComing] New game detected, initializing config file.")
            updateConfigFile("currentWinterStorm", 0)
            updateConfigFile("isWinterStorm", 0)
            updateConfigFile("currentYearChecked", 0)
            updateConfigFile("changeWeather", 0)
            updateConfigFile("timesWinterStorm", 0)
            updateConfigFile("warningMsgPopped", 0)
        end
    end)
end

alreadyLooping = false

RegisterHook("/Script/Engine.PlayerController:ClientRestart", function()
    print("[winterIsComing] Game Loaded")

    if alreadyLooping then
        -- print("[winterIsComing] There's already a loop running")
        return
    end

    initializeConfigFile()

    LoopAsync(30000, function() -- Loop every 30 seconds
        local PawnCPP = FindFirstOf("PawnCPP")
        if not PawnCPP:IsValid() then
            print("[winterIsComing] Couldn't get PawnCPP instance.\n")
            alreadyLooping = false
            return true
        end

        -- print("[winterIsComing] LoopAsync")
        alreadyLooping = true
        

        local checkedStorm = wasSpawnWinterStormCheckedThisYear()
        -- print(string.format("checkedStorm = %s", checkedStorm))
        if checkIfToSpawnWinterStorm(checkedStorm) then
            updateConfigFile("isWinterStorm", 1)
        end

        if config.isWinterStorm == 1 then
            if config.warningMsgPopped == 0 then
                print("[winterIsComing] SpawnWinterStorm Warning Message")
                PawnCPP:playEventMessage(FName("storm"), "Storm is approaching!", "The coming winter will be long and harsh, be prepared!")
                updateConfigFile("warningMsgPopped", 1)
            end
            spawnWinterStorm()
        else
            if config.warningMsgPopped == 1 then
                updateConfigFile("warningMsgPopped", 0)
            end
        end

        return false
    end)
end)

alreadyUpdateProblemUI = false

ExecuteWithDelay(5000, function ()
    RegisterHook("/Game/CPP_BP/MyPawnCPP_BP3.MyPawnCPP_BP3_C:updateProblemUI", function()
        if not alreadyUpdateProblemUI then
            alreadyUpdateProblemUI = true
            ExecuteWithDelay(3000, function ()
                ExecuteInGameThread(function()
                    local AWeatherMaster = FindFirstOf("WeatherMaster")
                    if not AWeatherMaster:IsValid() then
                        print("[winterIsComing] Couldn't get AWeatherMaster instance.\n")
                        return true
                    end

                    if config.changeWeather == 1 then
                        AWeatherMaster.snowTarget = 1
                        AWeatherMaster.targetSnowing = 1
                        AWeatherMaster.targetCloudiness = 1
                        AWeatherMaster.windTarget = 1
                        AWeatherMaster.fogLevel = 1
                        AWeatherMaster.snowfall = 1
                        AWeatherMaster.snowing = 1
                    end
                    alreadyUpdateProblemUI = false
                    return 
                end)
            end)
        else
            -- print("[winterIsComing] Already running alreadyUpdateProblemUI")
        end
    end)
end)

